import { world, system } from "@minecraft/server";

// Define the set of items to keep on death
const keptItems = new Set([
    "minecraft:leather_helmet",
    "minecraft:chainmail_helmet",
    "minecraft:iron_helmet",
    "minecraft:golden_helmet",
    "minecraft:diamond_helmet",
    "minecraft:netherite_helmet",
    "minecraft:turtle_helmet",
    "minecraft:leather_chestplate",
    "minecraft:chainmail_chestplate",
    "minecraft:iron_chestplate",
    "minecraft:golden_chestplate",
    "minecraft:diamond_chestplate",
    "minecraft:netherite_chestplate",
    "minecraft:leather_leggings",
    "minecraft:chainmail_leggings",
    "minecraft:iron_leggings",
    "minecraft:golden_leggings",
    "minecraft:diamond_leggings",
    "minecraft:netherite_leggings",
    "minecraft:leather_boots",
    "minecraft:chainmail_boots",
    "minecraft:iron_boots",
    "minecraft:golden_boots",
    "minecraft:diamond_boots",
    "minecraft:netherite_boots",
    "minecraft:shield",
    "minecraft:wooden_sword",
    "minecraft:stone_sword",
    "minecraft:iron_sword",
    "minecraft:golden_sword",
    "minecraft:diamond_sword",
    "minecraft:netherite_sword",
    "minecraft:bow",
    "minecraft:crossbow",
    "minecraft:trident",
    "minecraft:wooden_pickaxe",
    "minecraft:stone_pickaxe",
    "minecraft:iron_pickaxe",
    "minecraft:golden_pickaxe",
    "minecraft:diamond_pickaxe",
    "minecraft:netherite_pickaxe",
    "minecraft:wooden_axe",
    "minecraft:stone_axe",
    "minecraft:iron_axe",
    "minecraft:golden_axe",
    "minecraft:diamond_axe",
    "minecraft:netherite_axe",
    "minecraft:wooden_shovel",
    "minecraft:stone_shovel",
    "minecraft:iron_shovel",
    "minecraft:golden_shovel",
    "minecraft:diamond_shovel",
    "minecraft:netherite_shovel",
    "minecraft:wooden_hoe",
    "minecraft:stone_hoe",
    "minecraft:iron_hoe",
    "minecraft:golden_hoe",
    "minecraft:diamond_hoe",
    "minecraft:netherite_hoe",
    "minecraft:shears",
    "minecraft:flint_and_steel",
    "minecraft:fishing_rod",
    "minecraft:elytra",
    "minecraft:totem_of_undying",
    "minecraft:spyglass",
    "minecraft:carved_pumpkin"
]);

// Listen for player death events
world.afterEvents.playerDeath.subscribe(event => {
    const player = event.deadEntity;
    if (!player || !player.getComponent("minecraft:inventory")) return;

    const inventory = player.getComponent("minecraft:inventory").container;
    const itemsToKeep = [];

    // Iterate over the player's inventory and store items to keep
    for (let i = 0; i < inventory.size; i++) {
        const item = inventory.getItem(i);
        if (item && keptItems.has(item.typeId)) {
            itemsToKeep.push(item);
            inventory.setItem(i, undefined); // Remove item to prevent dropping
        }
    }

    // Restore the kept items to the player's inventory after a short delay
    system.run(() => {
        itemsToKeep.forEach(item => inventory.addItem(item));
    });
});